/* ***********************************************************
 * This file was automatically generated on 2012-09-17.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#include "bricklet_dual_relay.h"

#include <string.h>

#define FUNCTION_SET_STATE 1
#define FUNCTION_GET_STATE 2
#define FUNCTION_SET_MONOFLOP 3
#define FUNCTION_GET_MONOFLOP 4


typedef void (*monoflop_done_func_t)(uint8_t, bool);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	bool relay1;
	bool relay2;
} ATTRIBUTE_PACKED SetState_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetState_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	bool relay1;
	bool relay2;
} ATTRIBUTE_PACKED GetStateReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t relay;
	bool state;
	uint32_t time;
} ATTRIBUTE_PACKED SetMonoflop_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t relay;
} ATTRIBUTE_PACKED GetMonoflop_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	bool state;
	uint32_t time;
	uint32_t time_remaining;
} ATTRIBUTE_PACKED GetMonoflopReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t relay;
	bool state;
} ATTRIBUTE_PACKED MonoflopDoneCallback_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

int dual_relay_set_state(DualRelay *dual_relay, bool relay1, bool relay2) {
	if(dual_relay->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&dual_relay->write_mutex);

	SetState_ ss;
	ss.stack_id = dual_relay->stack_id;
	ss.function_id = FUNCTION_SET_STATE;
	ss.length = ipcon_leconvert_uint16_to(sizeof(SetState_));
	ss.relay1 = relay1;
	ss.relay2 = relay2;

	ipcon_device_write(dual_relay, (char *)&ss, sizeof(SetState_));

	ipcon_mutex_unlock(&dual_relay->write_mutex);

	return E_OK;
}

int dual_relay_get_state(DualRelay *dual_relay, bool *ret_relay1, bool *ret_relay2) {
	if(dual_relay->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&dual_relay->write_mutex);

	dual_relay->response.function_id = FUNCTION_GET_STATE;
	dual_relay->response.length = sizeof(GetStateReturn_);
	GetState_ gs;
	gs.stack_id = dual_relay->stack_id;
	gs.function_id = FUNCTION_GET_STATE;
	gs.length = ipcon_leconvert_uint16_to(sizeof(GetState_));

	ipcon_device_write(dual_relay, (char *)&gs, sizeof(GetState_));

	if(ipcon_device_expect_response(dual_relay) != 0) {
		ipcon_mutex_unlock(&dual_relay->write_mutex);
		return E_TIMEOUT;
	}

	GetStateReturn_ *gsr = (GetStateReturn_ *)dual_relay->response.buffer;
	*ret_relay1 = gsr->relay1;
	*ret_relay2 = gsr->relay2;

	ipcon_mutex_unlock(&dual_relay->write_mutex);

	return E_OK;
}

int dual_relay_set_monoflop(DualRelay *dual_relay, uint8_t relay, bool state, uint32_t time) {
	if(dual_relay->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&dual_relay->write_mutex);

	SetMonoflop_ sm;
	sm.stack_id = dual_relay->stack_id;
	sm.function_id = FUNCTION_SET_MONOFLOP;
	sm.length = ipcon_leconvert_uint16_to(sizeof(SetMonoflop_));
	sm.relay = relay;
	sm.state = state;
	sm.time = ipcon_leconvert_uint32_to(time);

	ipcon_device_write(dual_relay, (char *)&sm, sizeof(SetMonoflop_));

	ipcon_mutex_unlock(&dual_relay->write_mutex);

	return E_OK;
}

int dual_relay_get_monoflop(DualRelay *dual_relay, uint8_t relay, bool *ret_state, uint32_t *ret_time, uint32_t *ret_time_remaining) {
	if(dual_relay->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&dual_relay->write_mutex);

	dual_relay->response.function_id = FUNCTION_GET_MONOFLOP;
	dual_relay->response.length = sizeof(GetMonoflopReturn_);
	GetMonoflop_ gm;
	gm.stack_id = dual_relay->stack_id;
	gm.function_id = FUNCTION_GET_MONOFLOP;
	gm.length = ipcon_leconvert_uint16_to(sizeof(GetMonoflop_));
	gm.relay = relay;

	ipcon_device_write(dual_relay, (char *)&gm, sizeof(GetMonoflop_));

	if(ipcon_device_expect_response(dual_relay) != 0) {
		ipcon_mutex_unlock(&dual_relay->write_mutex);
		return E_TIMEOUT;
	}

	GetMonoflopReturn_ *gmr = (GetMonoflopReturn_ *)dual_relay->response.buffer;
	*ret_state = gmr->state;
	*ret_time = ipcon_leconvert_uint32_from(gmr->time);
	*ret_time_remaining = ipcon_leconvert_uint32_from(gmr->time_remaining);

	ipcon_mutex_unlock(&dual_relay->write_mutex);

	return E_OK;
}

int dual_relay_get_version(DualRelay *dual_relay, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]) {
	strncpy(ret_name, dual_relay->name, 40);

	ret_firmware_version[0] = dual_relay->firmware_version[0];
	ret_firmware_version[1] = dual_relay->firmware_version[1];
	ret_firmware_version[2] = dual_relay->firmware_version[2];

	ret_binding_version[0] = dual_relay->binding_version[0];
	ret_binding_version[1] = dual_relay->binding_version[1];
	ret_binding_version[2] = dual_relay->binding_version[2];

	return E_OK;
}

static int dual_relay_callback_wrapper_monoflop_done(DualRelay *dual_relay, const unsigned char *buffer) {
	MonoflopDoneCallback_ *mdc = (MonoflopDoneCallback_ *)buffer;

	((monoflop_done_func_t)dual_relay->registered_callbacks[mdc->function_id])(mdc->relay, mdc->state);
	return sizeof(MonoflopDoneCallback_);
}

void dual_relay_register_callback(DualRelay *dual_relay, uint8_t id, void *callback) {
	dual_relay->registered_callbacks[id] = callback;
}

void dual_relay_create(DualRelay *dual_relay, const char *uid) {
	ipcon_device_create(dual_relay, uid);

	dual_relay->expected_name = "Dual Relay Bricklet";

	dual_relay->binding_version[0] = 1;
	dual_relay->binding_version[1] = 0;
	dual_relay->binding_version[2] = 1;

	dual_relay->callback_wrappers[DUAL_RELAY_CALLBACK_MONOFLOP_DONE] = dual_relay_callback_wrapper_monoflop_done;
}
